<template>
  <el-dialog v-model="visible" :title="title"  destroy-on-close>
    <mind-form  v-model="model"
      @submit="onSubmit"
      ref="formulario"
      >
			<template v-slot="{form}" v-if="!isLoading">
        <el-row  >
          <el-col :xs="24" >
            <el-form-item label="Nombre" prop="name" required>
              <el-input v-model="form.name" style="margin-right:5px"/>
            </el-form-item>
          </el-col>
          <el-col :xs="24" >
            <el-form-item label="Descripción">
              <el-input type="textarea" v-model="form.description" />
            </el-form-item>
          </el-col>
        </el-row>
        <el-divider>Mapa</el-divider>
        <el-row  >
          <el-col :span="20">
            <el-row>
              <el-col :span="24" >
                <el-form-item label="Lat" prop="lat" >
                  <el-input v-model="form.lat" style="margin-right:5px"/>
                </el-form-item>
              </el-col>
              <el-col :span="24" >
                <el-form-item label="Long" prop="lng" >
                  <el-input v-model="form.lng" style="margin-right:5px"/>
                </el-form-item>
              </el-col>
              <el-col :span="20" >
                <el-form-item label="Zoom" prop="zoom" >
                  <el-input-number v-model="form.zoom" :min="1" :max="100" />
                </el-form-item>
              </el-col>
            </el-row>
          </el-col>
          <el-col :span="4" >
            <el-button
              title="Obtener Ubicación y Zoom del Mapa"
              type="primary"
              plain
              icon="MapLocation"
              @click="form.zoom=defaultZoom; form.lng=defaultLong; form.lat=defaultLat"
            />
          </el-col>
        </el-row>

      </template>
    </mind-form>
    <template #footer>
      <div class="dialog-footer">
        <el-button @click="visible = false">Cancelar</el-button>
        <el-button type="primary" @click="$refs.formulario.onSubmit()">
          Confirmar
        </el-button>
      </div>
    </template>
  </el-dialog>
</template>

<script setup>

  const visible = defineModel("visible", {type: Boolean})
  const model = defineModel({
    type: Object,
  })


  const props = defineProps({
    title: String,
    defaultZoom: Number,
    defaultLat: Number,
    defaultLong: Number,
  });


  const emit = defineEmits(["submit"])

  function onSubmit(v) {
    // model.value = v
    emit("submit", v)
  }


</script>